#ifndef EXPRTYPE_HH
#define EXPRTYPE_HH

namespace ExprType
{
    struct UnknownType;

    template<unsigned>
    struct ETType
    {
	typedef UnknownType Type;
    };
    

    template<typename T>
    struct ETArray
    {
	char array[1];
    };
    

    template<typename T>
    ETArray<T> etFunc(T& t);
#ifndef _MSC_VER
    template<typename T>
    ETArray<const T> etFunc(const T& t);
#endif

    template<typename T>
    T makeT();

#ifndef _MSC_VER    
    template<typename T>
    struct RValueLValueType
    {
	typedef T& Type;
    };

    template<typename T>
    struct RValueLValueType<const T>
    {
	typedef const T Type;
    };

    template<typename T>
    struct RValueLValueType<T&>
    {
	typedef T& Type;
    };
#else
    template<typename T>
    struct RValueLValueType
    {
	typedef T Type;
    };
#endif
}

#define REGISTER_EXPR_TYPE_SINGLE(type,value)\
namespace ExprType\
{\
    template<>\
    struct ETArray<type >\
    {\
        char array[value];\
    };\
    \
    template<>\
    struct ETType<value>\
    {\
	typedef type Type;\
    };\
}

#define REGISTER_EXPR_TYPE(type,value)\
REGISTER_EXPR_TYPE_SINGLE(type,value*4)\
REGISTER_EXPR_TYPE_SINGLE(type const,value*4+1)\
REGISTER_EXPR_TYPE_SINGLE(type volatile,value*4+2)\
REGISTER_EXPR_TYPE_SINGLE(type const volatile,value*4+3)


#define EXPR_TYPE_BEGIN ExprType::ETType<sizeof(ExprType::etFunc(
#define EXPR_TYPE_END ).array)>::Type
#define EXPR_TYPE(expr) EXPR_TYPE_BEGIN (expr) EXPR_TYPE_END


#define MAKE_T(type) (*((type*)0))


REGISTER_EXPR_TYPE(char,2)
    REGISTER_EXPR_TYPE(unsigned char,3)
    REGISTER_EXPR_TYPE(signed char,4)
    REGISTER_EXPR_TYPE(short,5)
    REGISTER_EXPR_TYPE(unsigned short,6)
    REGISTER_EXPR_TYPE(int,7)
    REGISTER_EXPR_TYPE(unsigned int,8)
    REGISTER_EXPR_TYPE(long,9)
    REGISTER_EXPR_TYPE(unsigned long,10)
    REGISTER_EXPR_TYPE(float,11)
    REGISTER_EXPR_TYPE(double,12)
    REGISTER_EXPR_TYPE(long double,13)
    REGISTER_EXPR_TYPE(bool,14)

    REGISTER_EXPR_TYPE(void*,15)
REGISTER_EXPR_TYPE(char*,16)
    REGISTER_EXPR_TYPE(unsigned char*,17)
    REGISTER_EXPR_TYPE(signed char*,18)
    REGISTER_EXPR_TYPE(short*,19)
    REGISTER_EXPR_TYPE(unsigned short*,20)
    REGISTER_EXPR_TYPE(int*,21)
    REGISTER_EXPR_TYPE(unsigned int*,22)
    REGISTER_EXPR_TYPE(long*,23)
    REGISTER_EXPR_TYPE(unsigned long*,24)
    REGISTER_EXPR_TYPE(float*,25)
    REGISTER_EXPR_TYPE(double*,26)
    REGISTER_EXPR_TYPE(long double*,27)
    REGISTER_EXPR_TYPE(bool*,28)

//     REGISTER_EXPR_TYPE(void,29)

    REGISTER_EXPR_TYPE(const void*,30)
REGISTER_EXPR_TYPE(const char*,31)
    REGISTER_EXPR_TYPE(const unsigned char*,32)
    REGISTER_EXPR_TYPE(const signed char*,33)
    REGISTER_EXPR_TYPE(const short*,34)
    REGISTER_EXPR_TYPE(const unsigned short*,35)
    REGISTER_EXPR_TYPE(const int*,36)
    REGISTER_EXPR_TYPE(const unsigned int*,37)
    REGISTER_EXPR_TYPE(const long*,38)
    REGISTER_EXPR_TYPE(const unsigned long*,39)
    REGISTER_EXPR_TYPE(const float*,40)
    REGISTER_EXPR_TYPE(const double*,41)
    REGISTER_EXPR_TYPE(const long double*,42)
    REGISTER_EXPR_TYPE(const bool*,43)

#endif
